//---------------------------------------------------------
// ID,BAUDRATE,RETURNDELAYTIMEύX
//                              Last Edit '11 04/11
// Copyright (c) BestTechnology CO.,LTD. 2005-2011
//---------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>

#include <AT91SAM7S.h>            // AT91SAM7S̓I/O`
#include <AT91SAM7S_BITDEFINE.h>  // AT91SAM7S̓I/Orbg`
#include <vic.h>                  // AT91SAM7S荞

#include <dx.h>                   // DynamixelCu

#define __UDP__                   // R\[֐̑I
#include "share\us.c"

#define _TIMEOUT 100

#define gotoxy(xx, yy)  _us_printf("\x1b[%d;%dH", yy + 1, xx + 1);
#define cls()           _us_puts("\x1b[2J");

typedef struct {
  uint8_t   id;
  uint8_t   baud;
  uint16_t  modelno;
  int       ud;
} TDX;

// wpingJԂ
bool rping (uint8_t id, int scancnt, uint16_t *err) {
  int i;
  for (i = 0; i < scancnt; i++) {
    if (!DX_Ping (id, _TIMEOUT, err)) return false;
    else DX_wait (10);
  }
  return true;
}

// foCX̃fNOfoCXԂ
char *devicename (uint16_t modelno) {
  int i;
  struct {
    uint16_t  modelno;
    char      name[10];
  } const static model[] = {
    { 0xffff, "UNKNOWN" },
    {     12, "AX-12(+)"},
    {     13, "AX-S1"   },
    {     18, "AX-18"   },
    {    116, "DX-116"  },
    {    117, "DX-117"  },
    {     24, "RX-24F"  },
    {     28, "RX-28"   },
    {     64, "RX-64"   },
    {    107, "EX-106+" },
    { 0x4001, "M168IO"  },
    { 0x4002, "9DOF"    },
    { 0x4004, "USS3"    },
    { 0x4010, "UDIII"   },
    {      0, ""        },
  };

  for (i = 0; model[i].name[0] != 0; i++)
    if (model[i].modelno == modelno) return (char *)&model[i].name;
  return (char *)&model[0].name;
}

void main (void) {

  bool AreYouSure (void) {
    char c;
    _us_putc (c = _us_getc ());
    return (c == 'y' || c == 'Y');
  }

  int i, j, k, b2;
  int id = 1, baud = 34, modelno = 0xffff;
  uint8_t dat;
  uint16_t wdat;
  char ch = '\0';
  TDX   alldx[254];
  uint16_t err;

  enableIRQ ();
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));
  init_syscall (NULL, NULL);
  DX_Init (2000000 / (baud + 1), 0, NULL, NULL);

  for (i = 0; i < 254; i++) {
    alldx[i].id = 0;
    alldx[i].baud = 34;
    alldx[i].modelno = 0xffff;
    alldx[i].ud = 5;
  }

  DX_wait (2000);
  _us_puts ("\nstart");
  while (1) {
    _us_printf ("\n\33[42mid:%d\33[m\33[45mbaud:%d\33[m(%s) >", id, baud, devicename (modelno));
    _us_putc (ch = _us_getc ());
    switch (ch) {
      // S{[[g&IDɑ΂ping
      // SWŃXLƂȂ莞Ԃv
      case 's':
      case 'S':
        for (i = 0; i < 254; i++) {
          alldx[i].id = 0;
          alldx[i].modelno = 0xffff;
        }
        i = 1; k = 0;
        _us_puts ("\nInput start baudrate (1..254) = ");
        _us_scanf ("%d", &i);
        if (i < 1) i = 1;
        else if (i > 254) i = 254;
        _us_puts ("Start scanning\n");
        // {[[g̃[v
        for (; i <= 254; i++) {
          // ID̃[v
          for (j = 0; j <= 253; j++) {
            // {[[gZo
            b2 = DX_ChangHostBaud (2000000 / (i + 1));
            _us_printf ("Baud=%d(%d[bps]) id=%d\33[K\r", i, b2, j);
            // ping
            if (DX_Ping (j, 1 + 450000 / b2, &err)) {
              // ÔߌfoCXɑ΂čēxping5sĊmF
              if (rping (j, 5, &err)) {
                // foCX̃{[[gƃfNO擾
                if (DX_ReadByteData (j, ADDRESS_BAUDRATE , &dat, _TIMEOUT, &err) && DX_ReadWordData (j, ADDRESS_MODEL_NUMBER , &wdat, _TIMEOUT, &err)) {
                  if (dat == i) {
                    _us_printf ("\33[46mFOUND\33[m <%s> id=%d, baud=%d(%dbps)\33[K\n", devicename (wdat), j, dat, b2);
                    alldx[k].id = j;
                    alldx[k].baud = i;
                    alldx[k++].modelno = wdat;
                  }
                } else
                  _us_printf ("\33[41mERROR\33[m Abnormal response id=%d, baud=%d(%dbps)\33[K\n", j, dat, b2);
              } else
                _us_printf ("\33[41mERROR\33[m Abnormal response id=%d, baud=%d(%dbps)\33[K\n", j, dat, b2);
            }
            if (_us_rx_buff ()) break;
          }
          if (_us_rx_buff ()) { _us_getc (); break; }
        }
        DX_ChangHostBaud (2000000 / (baud + 1));
        break;
      // ΏIDɑ΂pings
      // 20JԂ1xłsƃG[ƌȂ
      case 'p':
      case 'P':
        if (rping (id, 20, &err)) {
          _us_puts ("\n\33[46mSUCCESS\33[m");
          if (DX_ReadWordData (id, ADDRESS_MODEL_NUMBER , &wdat, _TIMEOUT, &err)) modelno = wdat;
          else modelno = 0xffff;
        } else
          _us_printf ("\n\33[41mERROR\33[m [err:$%04X]", err);
        break;
      // zXgRg[ΏۂƂIDύX
      // ڑꂽfoCXɂ͉Ȃ
      case 'i':
        j = id;
        _us_puts ("\nInput host id (0..253) = ");
        _us_scanf ("%d", &i);
        if (i != j) {
          if (i < 0) i = 0;
          else if (i > 253) i = 253;
          _us_printf ("Updated host id = %d", i);
          id = i;
        } else
          _us_puts ("Canceled");
        break;
      // zXgRg[̃{[[gύX
      // ڑꂽfoCXɂ͉Ȃ
      case 'b':
        j = baud;
        _us_puts ("\nInput host baud (1..254) = ");
        _us_scanf ("%d", &i);
        if (j != i) {
          if (i < 1) i = 1;
          else if (i > 254) i = 254;

          b2 = DX_ChangHostBaud (2000000 / (i + 1));
          _us_printf ("Updated host baud = %d (%d[bps])", i, b2);
          baud = i;
        } else
          _us_puts ("Canceled");
        DX_ChangHostBaud (2000000 / (baud + 1));
        break;
      // zXgRg[Ŏw肵IDƃ{[[gŒʐMłfoCXIDύX
      // ΃zXgRg[̑ΏIDύXꂽIDɍXV
      case 'I':
        _us_puts ("\nInput target id (0..253) = ");
        i = id;
        _us_scanf ("%d", &i);
        _us_printf ("Target id = %d\nAre you sure?(Y/N) ", i);
        if (AreYouSure ()) {
          // ЂƂ܂foCX݂̑mF
          if (rping (id, 20, &err)) {
            // ύXID݂ȂmF
            if (!rping (i, 20, &err)) {
              // ID
              if (DX_WriteByteData (id, ADDRESS_ID, i, _TIMEOUT, &err)) {
                // IDIDǂݏo
                if (DX_ReadByteData (i, ADDRESS_ID , &dat, _TIMEOUT, &err)) {
                  // vĂΖȂ
                  if (dat == i) {
                    id = i;
                    _us_printf ("\n\33[46mSUCCESS\33[m Target & host id= %d", i);
                    if (DX_ReadWordData (id, ADDRESS_MODEL_NUMBER , &wdat, _TIMEOUT, &err)) modelno = wdat;
                    else modelno = 0xffff;
                  }
                } else
                  _us_printf ("\n\33[41mERROR\33[m Fail to read id parameter");
              } else
                _us_printf ("\n\33[41mERROR\33[m Fail to write id parameter");
            } else
              _us_printf ("\n\33[41mERROR\33[m Existing id");
          } else
            _us_printf ("\n\33[41mERROR\33[m Not found id = %d", id);
        } else
          _us_puts ("\nCanceled");
        break;
      // zXgRg[Ŏw肵IDƃ{[[gŒʐMłfoCX̃{[[gύX
      // ΃zXgRg[̃{[[gύXꂽ{[[gɍXV
      case 'B':
        _us_puts ("\nInput target baud (1..254) = ");
        i = baud;
        _us_scanf ("%d", &i);
        _us_printf ("Target baud = %d:%d[bps]\nAre you sure?(Y/N) ", i, 2000000 / (i + 1));
        if (AreYouSure ()) {
          b2 = DX_ChangHostBaud (2000000 / (i + 1));
          DX_ChangHostBaud (2000000 / (baud + 1));
          // ЂƂ܂foCX݂̑mF
          if (rping (id, 20, &err)) {
            // {[[g
            if (DX_WriteByteData (id, ADDRESS_BAUDRATE, i, _TIMEOUT, &err)) {
              // zXgRg[̃{[[gXV
              DX_ChangHostBaud (2000000 / (i + 1));
              DX_wait (200);
              // {[[gǂݏo
              if (DX_ReadByteData (id, ADDRESS_BAUDRATE , &dat, _TIMEOUT, &err)) {
                // vĂΖȂ
                if (dat == i) {
                  baud = i;
                  _us_printf ("\n\33[46mSUCCESS\33[m Target & host baud = %d (%d[bps])", baud, 2000000 / (baud + 1));
                  if (DX_ReadWordData (id, ADDRESS_MODEL_NUMBER , &wdat, _TIMEOUT, &err)) modelno = wdat;
                  else modelno = 0xffff;
                }
              } else
                _us_printf ("\n\33[41mERROR\33[m Fail to write baud parameter");
            } else
              _us_printf ("\n\33[41mERROR\33[m Fail to write baud parameter");
          } else
            _us_printf ("\n\33[41mERROR\33[m Not found id = %d", id);

          DX_ChangHostBaud (2000000 / (baud + 1));
        } else
          _us_puts ("\nCanceled");
        break;
      // zXgRg[Ŏw肵IDƃ{[[gŒʐMłfoCX̉xύX
      case 'R':
        if (DX_ReadByteData (id, ADDRESS_RETURN_DELAY_TIME , &dat, _TIMEOUT, &err)) {
          _us_printf ("\nNow target return delay time = %d", dat);
          _us_puts ("\nInput target return delay time (0..254) = ");
          i = dat;
          _us_scanf ("%d", &i);
          _us_printf ("Target return delay time = %d\nAre you sure?(Y/N) ", i);
          if (AreYouSure ()) {
            // ЂƂ܂foCX݂̑mF
            if (rping (id, 20, &err)) {
              // xԂ
              if (DX_WriteByteData (id, ADDRESS_RETURN_DELAY_TIME, i, _TIMEOUT, &err)) {
                // xԂǂݏo
                if (DX_ReadByteData (id, ADDRESS_RETURN_DELAY_TIME, &dat, _TIMEOUT, &err)) {
                  // vĂΖȂ
                  if (dat == i) {
                    _us_printf ("\n\33[46mSUCCESS\33[m Target return delay time = %d", dat);
                    if (DX_ReadWordData (id, ADDRESS_MODEL_NUMBER , &wdat, _TIMEOUT, &err)) modelno = wdat;
                    else modelno = 0xffff;
                  }
                } else
                  _us_printf ("\n\33[41mERROR\33[m Fail to read return delay time parameter");
              } else
                _us_printf ("\n\33[41mERROR\33[m Fail to write return delay time parameter");
            } else
              _us_printf ("\n\33[41mERROR\33[m Not found id = %d", id);
          } else
            _us_puts ("\nCanceled");
        } else
          _us_printf ("\n\33[41mERROR\33[m Fail to read return delay time parameter");
        break;
      // zXgRg[Ŏw肵IDƃ{[[gŒʐMłfoCXeXg
      case 't':
      case 'T':
        _us_puts ("\nTest run\n");
        // fNO擾
        if (DX_ReadWordData (id, ADDRESS_MODEL_NUMBER , &wdat, _TIMEOUT, &err)) {
          int maxpos = 4095;
          switch (modelno = wdat) {
            case  12:
            case  18:
            case 116:
            case 117:
            case  24:
            case  28:
            case  64:
              maxpos = 1023;
            case 107:
              // ʒupƂČ݈ʒuǂݏo
              if (DX_ReadWordData (id, ADDRESS_PRESENT_POSITION, &wdat, _TIMEOUT, &err)) {
                i = 5; j = wdat;
                // gN~bg}Cɐݒ
                DX_SetTorqueLimit (id, 300);
                // L[܂ŉ^JԂ
                while (1) {
                  j += i;
                  if (j > maxpos) { i = -5; j = maxpos; }
                  else if (j < 0) { i = 5; j = 0; }
                  _us_printf ("Position = %d  \r", j);
                  // ʒuwߒlXV
                  if (!DX_WriteWordData (id, ADDRESS_GOAL_POSITION, j, _TIMEOUT, &err)) {
                    _us_printf ("\33[41mERROR\33[m Fail to write goal position [err:$%04X]", err);
                    break;
                  }
                  DX_wait (20);
                  if (_us_rx_buff ()) break;
                }
                if (_us_rx_buff ()) { _us_getc (); break; }
              } else
                _us_printf ("\33[41mERROR\33[m Fail to read present position [err:$%04X]", err);
              break;
            case 13:
              // L[܂ŋ擾JԂ
              while (1) {
                if (DX_ReadByteData (id, 27, &dat, _TIMEOUT, &err)) {
                  _us_printf ("Center ir = %d    \r", dat);
                } else {
                  _us_printf ("\33[41mERROR\33[m Fail to read ir [err:$%04X]", err);
                  break;
                }
                DX_wait (50);
                if (_us_rx_buff ()) break;
              }
              if (_us_rx_buff ()) { _us_getc (); break; }
              break;
            case  0x4004:
              // L[܂ŋ擾JԂ
              while (1) {
                if (DX_ReadWordData (id, 42, &wdat, _TIMEOUT, &err)) _us_printf ("Distance = %d    \r", wdat);
                DX_wait (50);
                if (_us_rx_buff ()) break;
              }
              if (_us_rx_buff ()) { _us_getc (); break; }
              break;
            case  0x4010:
              while (1) {
                if (DX_ReadByteData (id, 33, &dat, _TIMEOUT, &err)) {
                  dat ^= 1;
                  if (!DX_WriteByteData (id, 33, dat, _TIMEOUT, &err)) {
                    _us_printf ("\33[41mERROR\33[m Fail to write led [err:$%04X]", err);
                    break;
                  }
                } else {
                  _us_printf ("\33[41mERROR\33[m Fail to read led [err:$%04X]", err);
                  break;
                }
                DX_wait (50);
                if (_us_rx_buff ()) break;
              }
              break;
            default:
              _us_puts ("Not supported device");
              break;
          }
        } else
          _us_printf ("\33[41mERROR\33[m Fail to read model no [err:$%04X]", err);
        break;
      // ς̃foCXSČJԂeXg
      case 'c':
      case 'C':
        _us_puts ("\nTest run\n");

        if (alldx[0].modelno != 0xffff) {
          while (1) {
            for (i = 0; alldx[i].modelno != 0xffff; i++) {
              _us_printf(" [%d:%d]", alldx[i].id, alldx[i].baud);
              DX_ChangHostBaud (2000000 / (alldx[i].baud + 1));
              int midpos = 2047;
              switch (alldx[i].modelno) {
                case  12:
                case  18:
                case 116:
                case 117:
                case  24:
                case  28:
                case  64:
                  midpos = 511;
                case 107:
                  if (DX_SetTorqueLimit (alldx[i].id, 700)) {
                    if (DX_ReadWordData (alldx[i].id, ADDRESS_PRESENT_POSITION, &wdat, _TIMEOUT, &err)) {
                      j = wdat + alldx[i].ud;
                      if (j > midpos+200) { alldx[i].ud = -5; j = midpos+200; }
                      else if (j < midpos-200) { alldx[i].ud = 5; j = midpos-200; }
                      if (DX_SetPosition (alldx[i].id, j)) _us_printf("%d", wdat);
                      else _us_printf ("\33[41m?\33[m");
                    } else _us_printf("\33[41m$%04x\33[m", err);
                  } else _us_printf ("\33[41m?\33[m");
                  break;
                case 13:
                  if (DX_ReadByteData (id, 27, &dat, _TIMEOUT, &err)) {
                    _us_printf ("%d", dat);
                  } else _us_printf("\33[41m$%04x\33[m", err);
                  break;
                case  0x4004:
                  if (DX_ReadWordData (alldx[i].id, 42, &wdat, _TIMEOUT, &err)) _us_printf ("%d", wdat);
                  else _us_printf("\33[41m$%04x\33[m", err);
                  break;
                case  0x4010:
                  if (DX_ReadByteData (alldx[i].id, 33, &dat, _TIMEOUT, &err)) {
                    dat ^= 1;
                    if (DX_WriteByteData (alldx[i].id, 33, dat, _TIMEOUT, &err)) {
                      _us_printf ("%d", dat);
                    } else _us_printf("\33[41m$%04x\33[m", err);
                  } else _us_printf("\33[41m$%04x\33[m", err);
                  break;
                default:
                  break;
              }
              if (_us_rx_buff ()) break;
            }
            _us_printf("\33[K\r");
            if (_us_rx_buff ()) break;
          }
          if (_us_rx_buff ()) { _us_getc (); break; }
          DX_ChangHostBaud (2000000 / (baud + 1));
        }
        break;
      case 'H':
        cls();
        _us_puts ("Health check\n");
        if (alldx[0].modelno != 0xffff) {
          while (1) {
            for (i = 0; alldx[i].modelno != 0xffff; i++) {
              if (i == 0) gotoxy (0,1);
              DX_ChangHostBaud (2000000 / (alldx[i].baud + 1));
              DX_ReadWordData (alldx[i].id, ADDRESS_MODEL_NUMBER , &wdat, 10, &err);
              if (err) _us_printf(" \33[41m%3d:$%04x\33[m", alldx[i].id, err);
              else _us_printf(" \33[46m%3d:$%04x\33[m", alldx[i].id, err);
              if (_us_rx_buff ()) break;
              if (((i + 1) % 7) == 0) _us_puts ("\n");
            }
            if (_us_rx_buff ()) break;
          }
          if (_us_rx_buff ()) { _us_getc (); break; }
          DX_ChangHostBaud (2000000 / (baud + 1));
        }
        break;
      // scanŌfoCX񋓂
      case 'l':
      case 'L':
        if (alldx[0].modelno != 0xffff) {
          for (i = 0; alldx[i].modelno != 0xffff; i++) {
            _us_printf (
              "\n id=%d, baud=%d(%dbps) <$%04X:%s>",
              alldx[i].id,
              alldx[i].baud,
              2000000 / (alldx[i].baud + 1),
              alldx[i].modelno,
              devicename (alldx[i].modelno)
            );
          }
        }
        break;
      // CPUZbgău[g[_[ɖ߂
      case 0x1b:
      case 'q':
      case 'Q':
#if defined (__UDP__)
        udp_disconnect ();
        DX_wait (1000);
#endif
        RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
        break;
      // R}hXg\
      default:
        _us_puts (
          "\n----Command List----"
          "\n [p/P] Ping                 [s/S] Scan"
          "\n [i] Change host id         [I] Change target id"
          "\n [b] Change host baudrate   [B] Change target baudrate"
          "\n [R] Change target return delay time [t/T] Test run"
        );
        break;
    }
    _us_rx_purge ();
  }
}
