//---------------------------------------------------------
// j^LED
//                              Last Edit '11 04/08
// Copyright (c) BestTechnology CO.,LTD. 2005-2011
//---------------------------------------------------------
#include <stdio.h>

#include <AT91SAM7S.h>            // AT91SAM7S̓I/O`
#include <AT91SAM7S_BITDEFINE.h>  // AT91SAM7S̓I/Orbg`
#include <vic.h>                  // AT91SAM7S荞

#include <dx.h>                   // DynamixelCu

#define __UDP__                   // R\[֐̑I
#include "share\us.c"

//--------------------------------------------------------------
// L[͑҂
//--------------------------------------------------------------
char WaitForInputConsole (void) {
  char c;

  c = _us_getc ();
  if (c == '\33') { // ESCL[ŃvOI
#ifdef __UDP__
    udp_disconnect ();
    DX_wait (2000);
#endif
    RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
  }
  return c;
}

//--------------------------------------------------------------
// ESCL[ŃvOI
//--------------------------------------------------------------
void ESCReboot (void) {
  if (_us_rx_buff ()) {
    if (_us_getc () == '\33') {
#ifdef __UDP__
      udp_disconnect ();
      DX_wait (2000);
#endif
      RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
    }
  }
}

//----------------------------------------------------------------
// LED_
//----------------------------------------------------------------
void LedOnOff (uint8_t id, bool f) {
  int j, l2;
  uint8_t  param[128];
  static uint8_t tbuf[150], rbuf[150];
  uint16_t err;

  param[0] = ADDRESS_LED;
  param[1] = f & 1;
  j = DX_TxPacket(tbuf, id, INST_WRITE, param, 2, &err);
  DX_PrintBuffer(" <-",tbuf,j);
  j = DX_RxPacket(rbuf, sizeof(rbuf), &l2, _DX_READ_RESPONSE_TIME, &err);
  if (id != BROADCASTING_ID) {
    DX_PrintBuffer(" ->",rbuf,j);
    _us_printf("   err:$%04X\n", err);
  }
  
}

//----------------------------------------------------------------
// C
//----------------------------------------------------------------
void main (void) {
  // 荞݋
  enableIRQ ();

  // CONSOLE
  //  us.cɒ`ꂽ{[[gƑMobt@
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  // DX Library
  DX_Init (1000000, 7.4, _us_putc, NULL);

  WaitForInputConsole ();

  _us_puts("start\n");

  uint8_t id = 1;
//  uint8_t id = BROADCASTING_ID;

  while (1) {
    _us_puts ("LED ON\n");
    LedOnOff (id, true);
    DX_wait (1000);

    ESCReboot ();

    _us_puts ("LED OFF\n");
    LedOnOff (id, false);
    DX_wait (1000);

    ESCReboot ();
  }
}
